// unnamed package

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.util.*;


class Sheep
    extends Sprite
{
    static final int WIDTH = 15;
    static final int HEIGHT = 15;

    private final SheepdogCanvas canvas;
    private int[][][] animations = {{{0},                // stand up
                                     {1, 2, 3, 4}},      // run up
                                    {{5},                // stand left
                                     {6, 7, 8, 9}},      // run left
                                    {{10},               // stand down
                                     {11, 12, 13, 14}}}; // run down
    private int animationTick;
    private static int numSheep = 0;
    private static final int STAND = 0;
    private static final int RUN = 1;
    private int currentDirection = 8;
    private int currentDirection_big = 32;

    private int fordulniKell = 0;
    private int oldElem = 0;

    private int speed = 0;
    private int spx = 0;
    private int spy = 0;

    Sheep(SheepdogCanvas canvas)
    {
        super(SheepdogMIDlet.createImage("/kaforgas.png"), WIDTH, HEIGHT);
        defineCollisionRectangle(2, 2, WIDTH -4 , WIDTH-4 );
        defineReferencePixel(WIDTH/2, HEIGHT/2);

        this.canvas = canvas;
        animationTick = numSheep++;

    }


    void tick()
    {
        int x = getX()+getWidth()/2;
        int col = x/Field.TILE_WIDTH;
        int y = getY()+getHeight()/2;
        int row = y/Field.TILE_HEIGHT;
        int elem = canvas.getField().getElemXY(x,y);
        int irany = 0;
        boolean fordulhatx = (x%Field.TILE_WIDTH == Field.TILE_WIDTH/2);
        boolean fordulhaty = (y%Field.TILE_HEIGHT == Field.TILE_HEIGHT/2);
        boolean fordulhat = false;

        if( fordulniKell != 0 ) {
          if( currentDirection_big ==  0 ) {
            if( fordulniKell == -1)
              fordulhaty = (y % Field.TILE_HEIGHT <= Field.TILE_HEIGHT / 2 - 1);
            else
              fordulhaty = (y % Field.TILE_HEIGHT <= Field.TILE_HEIGHT / 2 - 4);
            if( fordulhaty )
              fordulhat = true;
          } else
          if( currentDirection_big == 32 ) {
            if( fordulniKell == 1 )
                fordulhatx = (x % Field.TILE_WIDTH <= Field.TILE_WIDTH / 2 - 2);
              else
                fordulhatx = (x % Field.TILE_WIDTH <= Field.TILE_WIDTH / 2 + 2);

            if( fordulhatx )
              fordulhat = true;
          } else
          if( currentDirection_big == 64 ) {
            if( fordulniKell == -1 )
              fordulhaty = (y % Field.TILE_HEIGHT >= Field.TILE_HEIGHT / 2 - 4);
            else
              fordulhaty = (y % Field.TILE_HEIGHT >= Field.TILE_HEIGHT / 2 - 1);
            if( fordulhaty )
              fordulhat = true;
          } else
          if( currentDirection_big == 96 ) {
            if( fordulniKell == 1 )
              fordulhatx = (x % Field.TILE_WIDTH >= Field.TILE_WIDTH / 2 + 2);
            else
              fordulhatx = (x % Field.TILE_WIDTH >= Field.TILE_WIDTH / 2 - 2);
            if( fordulhatx )
              fordulhat = true;
          } else fordulhat = true;
        }

        if( elem == oldElem ) {
          if( fordulhat && fordulniKell!=0 ) {
            if( fordulniKell==-1) left(); else right();
            speed = 0;
            if( currentDirection_big==0 || currentDirection_big==32 || currentDirection_big==64 || currentDirection_big==96 ) {
              fordulniKell = 0;
              tryMove();
            }
          } else
            tryMove();
        } else {
          if (Field.isIn(elem, Field.TURN_LEFT_TILES) ||
               ( (currentDirection_big !=  0) && Field.isIn(elem,Field.UP_TILES)) ||
               ( (currentDirection_big != 32) && Field.isIn(elem,Field.LEFT_TILES)) ||
               ( (currentDirection_big != 64) && Field.isIn(elem,Field.DOWN_TILES)) ||
               ( (currentDirection_big != 96) && Field.isIn(elem,Field.RIGHT_TILES))
              )
            fordulniKell = -1;
          if( currentDirection_big == 32 && elem == 11 &&
              ((canvas.getField().getElemColRow(col-1,row+1) == 15 ) ||
               (canvas.getMidlet().random(200)>100)
              )
            )
            fordulniKell = 1;
          if( currentDirection_big == 0 && elem == 14 &&
              ((canvas.getField().getElemColRow(col-1,row-1) == 18 ) ||
               (canvas.getMidlet().random(200)>100)
              )
            )
            fordulniKell = 1;
          if( currentDirection_big == 96 && elem == 13 &&
              ((canvas.getField().getElemColRow(col+1,row-1) == 17 ) ||
               (canvas.getMidlet().random(200)>100)
              )
            )
            fordulniKell = 1;
          if( currentDirection_big == 64 && elem == 12 &&
              ((canvas.getField().getElemColRow(col+1,row+1) == 16 ) ||
               (canvas.getMidlet().random(200)>100)
              )
            )
            fordulniKell = 1;
        }

        setStandingAnimation();
        oldElem = elem;
//        int dogDistance = Math.abs(dx) + Math.abs(dy);
//        if (SheepdogMIDlet.random(dogDistance - 10) == 0)
//        {
//            SoundEffects.getInstance().startSheepSound();
//        }
    }




    private void tryMove()
    {
        Field field = canvas.getField();
        boolean blocked = true;

        speedUp();
//        speed=10;
        int newX = (speed*Sheepdog.myCos(currentDirection));
        int newY = (speed*Sheepdog.mySin(currentDirection));

// up
//        if( currentDirection>=28 || currentDirection<=4 ) {
          if (!field.containsImpassableArea( ( (spx + newX) / Sheepdog.MAX_SP)+getWidth()/2,
                                            ( (spy + newY) / Sheepdog.MAX_SP)+getHeight()/2,
                                            getWidth(),
                                            1)) {
           blocked = false;
          } else {
            if (speed >= 30)
              speed -= 30;
            else
              speed = 0;
        //  canvas.vibrate(VIBRATION_MILLIS);
          }

        boolean success = false;
        if (!blocked)
        {
          spx += newX;
          spy += newY;

          setPosition(spx/Sheepdog.MAX_SP,spy/Sheepdog.MAX_SP);

            if (canvas.overlapsOtherSheep(this) ||
                canvas.overlapsSheepdog(this))
            {
              spx -= newX;
              spy -= newY;
              setPosition(spx/Sheepdog.MAX_SP,spy/Sheepdog.MAX_SP);
            }
            else
            {
                success = true;
            }
        }

    }

    private void setStandingAnimation()
    {
      if (currentDirection >= 17)
      {
          setFrame((32-currentDirection)%17);
          setTransform(TRANS_MIRROR);
      }
      else
      {
          setFrame(currentDirection%17);
          setTransform(TRANS_NONE);
      }
    }

    public int getDirection() {return currentDirection_big;}

    public void setDirection(int new_direction) {
      currentDirection_big=new_direction;
      currentDirection=currentDirection_big/4;
    }

    public void right() {
      if( currentDirection_big > 0 )
        currentDirection_big--;
      else
        currentDirection_big=127;
      currentDirection=currentDirection_big/4;
    }

    public void left() {
      if( currentDirection_big < 127 )
        currentDirection_big++;
      else
        currentDirection_big=0;
      currentDirection=currentDirection_big/4;
    }

    public void setSpPosition(int newX, int newY) {
      if( newX>canvas.getField().WIDTH_IN_TILES*canvas.getField().TILE_WIDTH ||
          newX<0 ||
          newY>canvas.getField().HEIGHT_IN_TILES*canvas.getField().TILE_HEIGHT ||
          newY<0
          ) {
        newX = 0;
        newY = 0;
      }

      spx = newX * Sheepdog.MAX_SP;
      spy = newY * Sheepdog.MAX_SP;
      setPosition(newX,newY);
    }

    public void speedUp() {
      if( speed < (Sheepdog.MAX_SPEED*3)/4 )
        speed += 3;
    }

    public void speedDown() {
      if( speed >=15 ) speed -= 15;
      else speed=0;
    }

    public int getOldElem() {
      return oldElem;
    }

    public int getFordulniKell() {
      return fordulniKell;
    }

}
